package Rumba;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class BidCollection {
	private final List<EvaluatedBid> bids;
	private final Random random;

	public BidCollection() {
		
		this.bids = new ArrayList<EvaluatedBid>();
		this.random = new Random();
	}
	
	public void addBid(EvaluatedBid bid) {
		this.bids.add(bid);		
	}
	
	public EvaluatedBid lastBid() {
		if (this.bids.isEmpty()) {
			return null;
		}
		
		return this.bids.get(this.bids.size()-1);		
	}
	
	public EvaluatedBid randomBid() {
		if (this.bids.isEmpty()) {
			return null;
		}
		
		int index = random.nextInt(this.bids.size());
		return this.bids.get(index);
	}
}
