package Rumba;

import negotiator.Timeline;

public class ThresholdCalculator {
	
	private static final double DISCOUNT_THRESHOLD = 0.9;
	private static final double Ka = 0.05;
	private static final double exponent = 0.05;
	private final double discountFactor;
	private final Timeline timeline;
	private final double minUtil;
	private final double maxUtil;
	
	public ThresholdCalculator(Timeline timeline, double discountFactor, 
			double minUtil, double maxUtil) {
		this.timeline = timeline;
		this.minUtil = minUtil;
		this.maxUtil = maxUtil;
		
		if (discountFactor <= 1 && discountFactor > 0 ) {
			this.discountFactor = discountFactor;
		} 
		else {
			this.discountFactor = 1;
		}
	}
	
	public double getThreshold() {
		final double k = ThresholdCalculator.Ka;
		double exponent = ThresholdCalculator.exponent;
		final double discountFactor = this.discountFactor;
		final double time = this.timeline.getTime();		
		double max = this.maxUtil;
		double min = this.minUtil;
		double coefficient;
								
		if(discountFactor >= DISCOUNT_THRESHOLD) {
			coefficient = k + (1 - k) * Math.pow(time/discountFactor, 1/exponent);
			return min + (1-coefficient) * (max-min);
		}
		else {
			exponent = exponent * discountFactor;
			coefficient = k + (1 - k) * Math.pow(time, 1/exponent);
			return min + (1-coefficient) * (max - min);
		}
	}
	
}
