package agents;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Random;

import negotiator.Agent;
import negotiator.Bid;
import negotiator.actions.Accept;
import negotiator.actions.Action;
import negotiator.actions.Offer;
import negotiator.issue.Issue;
import negotiator.issue.IssueDiscrete;
import negotiator.issue.IssueInteger;
import negotiator.issue.IssueReal;
import negotiator.issue.Value;
import negotiator.issue.ValueInteger;
import negotiator.issue.ValueReal;



public class Agent_YTY extends Agent{
	
    private Action action_of_partner=null;
    private Bid preBid=null;
    private boolean first;
    private boolean time_095;
    private double dloop;
    private double t_value=0.9;//l
    
    public void init(){
	first=true;
	time_095=true;
	}

    public static String getVersion() { return "1.0"; }


    public void ReceiveMessage(Action opponentAction){
	action_of_partner = opponentAction;
    }


    public Action chooseAction(){
	Action action = null;
	try{
	    if(action_of_partner==null) action = chooseBid();
	    if(action_of_partner instanceof Offer){
		Bid partnerBid = ((Offer)action_of_partner).getBid();
		double offeredUtility = getUtility(partnerBid);
		if(first){
		    if (offeredUtility>=1.0){
			action = new Accept(getAgentID());
		    }else{
			action = chooseBid();
		    }
		}else{
		    if (offeredUtility>getUtility(preBid)){
			action = new Accept(getAgentID());
		    }else{
			action = chooseBid();
		    }
		}
	    }
	} catch (Exception e) {
	    action=new Accept(getAgentID());
	}
	return action;
    }
    
    
      
    private Action chooseBid(){
	Bid nextBid=null;
	double max_utility=0;
	Bid maxBid=null;


	//plőƂȂrbg
	try { maxBid = utilitySpace.getMaxUtilityBid();}
	catch (Exception e){}
	if(maxBid == null) return (new Accept(getAgentID()));
	max_utility=getUtility(maxBid);



	//chooserbgŏɌĂ΂ꂽ
	if(first){
	    nextBid=maxBid;
	    preBid=nextBid;
	    first=false;
	    return (new Offer(getAgentID(),nextBid));
	}
	

	double time = timeline.getTime();
	//t_value l
	if(time<0.3){
	    t_value=0.96;
	}else if(time<0.5){
	    t_value=0.93;
	}else if(time<0.7){
	    t_value=0.90;
	}else if(time<0.8){
	    t_value=0.88;
	}else if(time<0.85){
	    t_value=0.86;
	}else if(time<0.90){
	    t_value=0.84;
	}else {
	    t_value=0.80;
	}



	if(time<0.95){
	    try { nextBid = getRandomBid();}
	    catch (Exception e){}
	    if(nextBid == null) return (new Accept(getAgentID()));
	    if(Math.random()>=0.34){
		if(max_utility >= t_value){
		    dloop=0.1;
		    int loop_num=0;
		    double pre_Utility=getUtility(preBid);
		    double next_Utility=getUtility(nextBid);
		    while((pre_Utility-next_Utility)>dloop || next_Utility<t_value || next_Utility>1.05){
			try { nextBid = getRandomBid();}
			catch (Exception e){}
			if(nextBid == null) return (new Accept(getAgentID()));
			if(loop_num==1000){
			    dloop+=0.01;
			    loop_num=0;
			}
			loop_num++;
			next_Utility=getUtility(nextBid);
		    }
		}else{
		    nextBid=preBid;
		}
	    }else{ //񎦂offerŒ肳邱ƂɂČ􂷂??Ƃhp(Math.randomŎl0.34菬)
		dloop=0.01;
		int loop_num=0;
		double next_Utility=getUtility(nextBid);
		while(preBid==nextBid || next_Utility<t_value-dloop || next_Utility>t_value+dloop || next_Utility>1.05){
		    try { nextBid = getRandomBid();}
		    catch (Exception e){}
		    if(nextBid == null) return (new Accept(getAgentID()));
		    if(loop_num==1000){
			dloop+=0.01;
			loop_num=0;
		    }
		    loop_num++;
		    next_Utility=getUtility(nextBid);
		}
	    }
	}else{
	    if(time_095){
		try { nextBid = getRandomBid();}
		catch (Exception e){}
		if(nextBid == null) return (new Accept(getAgentID()));
		
		//0.95ȍ~ŎgBIT(pl0.8炢̂̂)
		dloop=0.01;
		int loop_num=0;
		double next_Utility=getUtility(nextBid);
		while(next_Utility<t_value-dloop ||next_Utility>t_value+dloop ||next_Utility>1.05){
		    try { nextBid = getRandomBid();}
		    catch (Exception e){}
		    if(nextBid == null) return (new Accept(getAgentID()));
		    if(loop_num==1000){
			dloop+=0.01;
			loop_num=0;
		    }
		    loop_num++;
		    next_Utility=getUtility(nextBid);
		}
		time_095=false;

	    }else{
		nextBid=preBid;
	    }
    	}
    	
	preBid=nextBid;
	return (new Offer(getAgentID(),nextBid));
    }
    
	
	
    private Bid getRandomBid() throws Exception
    {
	HashMap<Integer, Value> values = new HashMap<Integer, Value>();
	ArrayList<Issue> issues=utilitySpace.getDomain().getIssues();
	Random randomnr= new Random();
	Bid bid=null;
	    for(Issue lIssue:issues)
		{
		    switch(lIssue.getType()) {
		    case DISCRETE:
			IssueDiscrete lIssueDiscrete = (IssueDiscrete)lIssue;
			int optionIndex=randomnr.nextInt(lIssueDiscrete.getNumberOfValues());
			values.put(lIssue.getNumber(), lIssueDiscrete.getValue(optionIndex));
			break;
		    case REAL:
			IssueReal lIssueReal = (IssueReal)lIssue;
			int optionInd = randomnr.nextInt(lIssueReal.getNumberOfDiscretizationSteps()-1);
			values.put(lIssueReal.getNumber(), new ValueReal(lIssueReal.getLowerBound() + (lIssueReal.getUpperBound()-lIssueReal.getLowerBound())*(double)(optionInd)/(double)(lIssueReal.getNumberOfDiscretizationSteps())));
			break;
		    case INTEGER:
			IssueInteger lIssueInteger = (IssueInteger)lIssue;
			int optionIndex2 = lIssueInteger.getLowerBound() + randomnr.nextInt(lIssueInteger.getUpperBound()-lIssueInteger.getLowerBound());
			values.put(lIssueInteger.getNumber(), new ValueInteger(optionIndex2));
			break;
		    default: throw new Exception("issue type "+lIssue.getType()+" not supported by Agent_YTY");
		    }
		}
	    bid=new Bid(utilitySpace.getDomain(),values);
	return bid;
    }
}
